import audioop

from cuisine.shownodes.effect import Effect,register

import logging
log=logging.getLogger("effect")

class Audiomixdown(Effect):
    
    def process(self,t,fraction,component,inputs):
        global tmp
        if component!='audio' or 'mix' not in inputs:
            log.warn("requested '%s' from an effect that doesn't support it"%component)
            return None


        acc=None
        for samples,scl in zip(self.framesforinputs(t,'audio',inputs.mix),
                               self.curvesforinputs(t,'audioLevel',inputs.mix)):
            if scl is None:
                # having no curve means the track is mixed in at full level
                scl=1

            if samples is not None:#  and (scl>0 or acc is None): # <<-- this optimization doesnt help speed, and it makes zero-level audio play at full volume (!)
                if scl!=1.0:
                    samples=audioop.mul(samples,2,scl)
                if acc is None:
                    acc=samples
                else:
                    if 0:
                        # this is my repulsive way of handling the
                        # unlocked audio-- i truncate each frame's sample
                        # count to the minimum length. this means that frames
                        # where the samples differ on any audio tracks are going
                        # to be cut short!

                        l=min(len(acc),len(samples))
                        acc=audioop.add(acc[:l],samples[:l],2)
                    else:
                        # alternate algorithm for matching
                        # different-length frames. still bad.  the
                        # first input we see dictates the final number
                        # of samples. any subsequent frames are either
                        # clipped or padded (with the last sample's
                        # value). one sample is 4 bytes (2 chans of 16bit).
                        if len(samples)<len(acc):
                            # pad
                            samples=samples+samples[-4:]*((len(acc)-len(samples))/4)
                        elif len(samples)>len(acc):
                            # crop
                            samples=samples[:len(acc)]
                        try:
                            acc=audioop.add(acc,samples,2)
                        except audioop.error:
                            log.error("can't mix len acc=%i, len samples %i" % (len(acc),len(samples)))
                            
        return acc

register(Audiomixdown)
