
cdef extern from "glib.h":
    ctypedef struct GObject

cdef extern from "pygobject.h":
    ctypedef struct PyGObject:
        GObject *obj

cdef extern from "gdk/gdkx.h":
    ctypedef struct GdkWindow
#    int GDK_WINDOW_XWINDOW(GdkWindow *)

cdef extern from "libgnomecanvas/libgnomecanvas.h":
    ctypedef struct GnomeCanvas:
        int close_enough
    GnomeCanvas *GNOME_CANVAS(GObject *)

        
# getxid is only used by pour, which no one is using
#def getxid(gdkwindow):
#    return gdkwindow.xid
##     cdef GdkWindow *win
##     win = PyGdkWindow_Get(gdkwindow)
##     if win == NULL:
##         raise RuntimeError("argument must be GdkWindow")

##     return GDK_WINDOW_XWINDOW(win)

def setcanvasclose_enough(gnome_canvas, close_enough):
    """
    gnome canvas has no accessor for the close_enough field in the GnomeCanvas
    structure. In fact, I can't find anyplace that even sets a default for the
    field!

    """
    cdef GObject *obj
    cdef GnomeCanvas *can
    
    obj = (<PyGObject *>gnome_canvas).obj

    can = GNOME_CANVAS(obj)
    if can == NULL:
        raise RuntimeError("first argument must be GnomeCanvas")

    can.close_enough = close_enough


