from __future__ import division
import pygame,time,math,base64,StringIO,random
from OpenGL import GL,GLU

"""
__GL_FSAA_MODE  GeForce4 MX, GeForce4 4xx Go, Quadro4 380,550,580 XGL,
                and Quadro4 NVS
-----------------------------------------------------------------------
  0             FSAA disabled
  1             2x Bilinear Multisampling
  2             2x Quincunx Multisampling <---- this looks best on lines tests
  3             FSAA disabled
  4             2 x 2 Supersampling
  5             FSAA disabled
  6             FSAA disabled
  7             FSAA disabled
"""

demojpg=base64.decodestring('/9j/4AAQSkZJRgABAQEASABIAAD/2wBDABsSFBcUERsXFhceHBsgKEIrKCUlKFE6PTBCYFVlZF9V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\ntQQD2sQGJHaLKFjf1EdpINnykiH/2Q==\n')

import cuisine.toss2.ogldraw as draw
from cuisine.toss2.ogldisplay import opengldisplay

def drawlinetoy(ang):
    for i in [x/100*6.28-ang for x in range(100)]:
        s,c=math.sin(i),math.cos(i)
        draw.line((0,0),(100*s,100*c),(1,.5,1))

disp=opengldisplay(windowsize=(1200,500))

img=draw.image(
    filename="demo.jpg")
    #filestring=demojpg,filetype="jpg")

ang=0
while 1:
    ang+=.0053

    start=time.time()
    disp.clearscreen()

    drawlinetoy(ang)

    if 1:
        for x in range(-20,20):
            for y in range(-15,15):
                p1=(x/20,y/15)
                draw.rect(p1,
                          ((x+.6)/20,(y+.6)/15),
                          fillcolor=(1,1,1),outlinecolor=(1,0,0))
                #draw.text(p1,"x=%d"%x,size=15,color=(0,0,1))
                if x*y%25==0:
                    img.draw(p1,.2)

    draw.text((-1,-1),"%2.4f"%ang,size=20,color=(.6,1,.3))

    if 0: # flying image
        s=math.sin(ang)
        scl=s/2+.5+.3
        img.draw((math.sin(ang),math.cos(ang)),scl)

    print "draw %.2f" % ((time.time()-start)*1000)
    disp.flip()

    disp.pollevents()

    time.sleep(.01)


