
from cuisine.utils import make_attributes_from_args

class Nodeview:
    """base for objects that represent a data node on the display. the view sticks
    to the node forever.

    these views draw themselves, and they make UI events.
    """

    node=None # what node does this view follow?
    # the node may have a more specific name too.

    def __init__(self,tkmaster,openglmaster,layout,node):
        """
        any view can draw on the tracks panel and on the opengl
        widget. views access the Layout to convert between coordinate
        systems.

        """
        make_attributes_from_args('tkmaster','openglmaster','layout','node')


    def redraw(self):
        
        """ this completely freshens the view, updating all
        coordinates. it should work if the opengl canvas was
        completely cleared.  """

        pass
    
