import ez_setup
ez_setup.use_setuptools()

import os, commands, sys
from setuptools import setup, find_packages, Extension

import Pyrex.Compiler.Main
Pyrex.Compiler.Main.default_options.include_path=["cuisine"]
# see http://codespeak.net/svn/lxml/trunk/lxmldistutils.py for alternative

# include_path workaround isn't good enough; need to let pyrex find
# its wrong-named file
os.system("cp -v cuisine/pyxbuf.pxd cuisine/effects/cuisine.pyxbuf.pxd")

def pkg_config_args(cmd):
    line = commands.getoutput(cmd)
    if "not found" in line:
        raise ValueError(line)
    words = line.split()
    if not words:
        raise ValueError("%r returned nothing" % cmd)
    return words

if 1:
    gtk_extensions = [
        Extension(
        'cuisine.toss.pygtkutil',
        ['cuisine/toss/pygtkutil.pyx'],
        extra_compile_args=
        pkg_config_args("pkg-config --cflags libgnomecanvas-2.0 pygtk-2.0"),
      extra_link_args=pkg_config_args("pkg-config --libs libgnomecanvas-2.0"),
        ),
        ]
else:
    gtk_extensions = []

setup(name="Cuisine",
      version="3.8",
      
      packages=find_packages(),
      ext_modules=[Extension('cuisine.effects.matte',
                             ['cuisine/effects/matte.pyx',
                              'cuisine/effects/matte_c.c'],
                             ),
                   Extension('cuisine.pyxbuf', ['cuisine/pyxbuf.pyx']),
                   Extension('cuisine.libdv', ['cuisine/libdv.pyx',
                                               'cuisine/libdv_funcs.c'
                                               ],
                             libraries=['dv']),
                   Extension('cuisine.pygame_blit',
                             ['cuisine/pygame_blit.pyx',
                              'cuisine/pygame_blit_c.c'],
                             extra_compile_args=pkg_config_args(
    "sdl-config --cflags"),
                             libraries=['SDL'],                             
                             ),
                   ] + gtk_extensions,
      scripts=["bin/"+s for s in os.listdir("bin")
               if not s.endswith("~") and not s.startswith(".")],

      install_requires=[
        #'shuttlepro', # quite optional
        'Louie', 
        'skim',
        #'Pygame', # >=1.7.1 ? but install doesnt do the .h files that i need
        #'Numeric', missing dl, at http://osdn.dl.sourceforge.net/sourceforge/numpy/Numeric-24.2.tar.gz
        #'PyXML', # waiting for https://sourceforge.net/tracker/index.php?func=detail&aid=1319879&group_id=6473&atid=106473
        # http://projects.bigasterisk.com/timecode-1.tar.gz
        # http://gnosis.cx/download/Gnosis_Utils-current.tar.gz (for smil)
        # pymedia, newer version is at http://voxel.dl.sourceforge.net/sourceforge/pymedia/pymedia-1.3.5.0.tar.gz

        # using SDL 1.2.9
                        ],

# i don't actually want this to register properly
#      description="Video editing system",
# but i turn on the next 3 to silence distutils warnings
      author="Drew Perttula",
      author_email="drewp@cuisine.bigasterisk.com",
      url="http://cuisine.bigasterisk.com/",
#      classifiers=[ # http://www.python.org/pypi?:action=list_classifiers
#    "Development Status :: 5 - Production/Stable",
#    "Environment :: X11 Applications",
#    "Operating System :: POSIX :: Linux",
#    "Programming Language :: Python",
#    "Topic :: Multimedia :: Video :: Non-Linear Editor",
#    ],
     )

